#include <stdio.h>
#include <stdlib.h>

#include <mevt.h>

int cle[24][16] = {
	{ 'C',' ','M', 0,                           4,0,1,0,1,1,0,2,0,1,0,1 },
	{ 'D','b','M',-5,                         1,4,0,1,0,1,1,0,2,0,1,0 },
	{ 'D',' ','M', 2,                       0,1,4,0,1,0,1,1,0,2,0,1 },
	{ 'E','b','M',-3,                     1,0,1,4,0,1,0,1,1,0,2,0 },
	{ 'E',' ','M', 4,                   0,1,0,1,4,0,1,0,1,1,0,2 },
	{ 'F',' ','M',-1,                 2,0,1,0,1,4,0,1,0,1,1,0 },
	{ 'F','#','M', 6,               0,2,0,1,0,1,4,0,1,0,1,1 },
	{ 'G',' ','M', 1,             1,0,2,0,1,0,1,4,0,1,0,1 },
	{ 'A','b','M',-4,           1,1,0,2,0,1,0,1,4,0,1,0 },
	{ 'A',' ','M', 3,         0,1,1,0,2,0,1,0,1,4,0,1 },
	{ 'B','b','M',-2,       1,0,1,1,0,2,0,1,0,1,4,0 },
	{ 'B',' ','M', 5,     0,1,0,1,1,0,2,0,1,0,1,4 },
	{ 'A',' ','m', 0,                           1,0,1,0,2,1,0,0,1,4,0,1 },
	{ 'B','b','m',-5,                         1,1,0,1,0,2,1,0,0,1,4,0 },
	{ 'B',' ','m', 2,                       0,1,1,0,1,0,2,1,0,0,1,4 },
	{ 'C',' ','m',-3,                     4,0,1,1,0,1,0,2,1,0,0,1 },
	{ 'C','#','m', 4,                   0,4,0,1,1,0,1,0,2,1,0,0 },
	{ 'D',' ','m',-1,                 0,1,4,0,1,1,0,1,0,2,1,0 },
	{ 'D','#','m', 6,               0,0,1,4,0,1,1,0,1,0,2,1 },
	{ 'E',' ','m', 1,             1,0,0,1,4,0,1,1,0,1,0,2 },
	{ 'F',' ','m',-4,           2,1,0,0,1,4,0,1,1,0,1,0 },
	{ 'F','#','m', 3,         0,2,1,0,0,1,4,0,1,1,0,1 },
	{ 'G',' ','m',-2,       1,0,2,1,0,0,1,4,0,1,1,0 },
	{ 'G','#','m', 5,     0,1,0,2,1,0,0,1,4,0,1,1 }
};

long cle_nb[12];


int cle_reset ( )
{
	int i;
	
	for ( i = 0; i < 12; i++ )
		cle_nb[i] = 0;

	return 0;
}

int cle_note ( int canal, int note )
{
	int poids;

	switch ( canal )
	{
		case 1:	/* UK */
		case 4:	/* LEAD */
			poids = 1;
			break;

		case 2:	/* LK */
		case 5:	/* LK */
			poids = 3;
			break;

		case 3:	/* PD */
			poids = 4;
			break;

		default:
			poids = 0;
			break;
	}
	
	cle_nb[note % 12] += poids;
		
	return 0;
}

BYTE cle_stat ( char *nom_cle )
{
	int c;
	int n;
	long val[24];
	int cle_max = 0;
	long max = 0;

	for ( c = 0; c < 24; c++ )
	{
		val[c] = 0;
		for ( n = 0; n < 12; n++ )
			val[c] += cle[c][4+n] * cle_nb[n];
		if ( max < val[c] )
		{
			max = val[c];
			cle_max = c;
		}
	}

	if ( nom_cle != NULL )
	{
		if (cle[cle_max][2] == 'M' )
			sprintf ( nom_cle, "%c%c majeur (%d %c)", cle[cle_max][0], cle[cle_max][1],
				abs(cle[cle_max][3]), cle[cle_max][3] >= 0 ? '#' : 'b' );
		else
			sprintf ( nom_cle, "%c%c mineur (%d %c)", cle[cle_max][0], cle[cle_max][1],
				abs(cle[cle_max][3]), cle[cle_max][3] >= 0 ? '#' : 'b' );
	}

	return  (BYTE)( ( cle[cle_max][3] + 256 ) & 0xFF );
}


