#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <mevt.h>

int evr_restart ( )
{
	ef_set ( 256 );
	return 0;
}
	
int evr_open ( char * nom )
{
	ef_r_open ( nom );
	evr_restart ( );
	return 0;
}

int evr_close ( )
{
	ef_close ( );
	return 0;
}

int evr_token ( enum TOKEN *code, int *parm1, int *parm2, int *parm3 )
{
#define RET(T,P1,P2,P3)	{ *code=(T); *parm1=(P1); *parm2=(P2); *parm3=(P3); return 0; }
	BYTE c,p1,p2;
	int i;
	BYTE canal;

	c = ef_read_B ( );

	if ( ef_eof() )
		RET(TOKEN_EOF,0,0,0)

	switch ( c )
	{
		case 0xf3: /* temps 1 octet */
			p1 = ef_read_B ( );
			RET(TOKEN_TIME,p1,0,0)
			break;

		case 0xf4: /* temps 2 octets */
			p1 = ef_read_B ( );
			p2 = ef_read_B ( );
			RET(TOKEN_TIME,(int)p1 + 128 * (int)p2,0,0)
			break;

		case 0xfe:
			p1 = ef_read_B ( );
			switch ( p1 )
			{
				case 0x78:	/* tick MIDI */
					RET(TOKEN_TICK,0,0,0)
					break;

				case 0x7a:	/* Start */
					RET(TOKEN_START,0,0,0)
					break;

				case 0x7c:	/* Stop */
					RET(TOKEN_STOP,0,0,0)
					break;

				default:
					RET(TOKEN_XFE,p1,0,0)
					break;
			}
			break;

		case 0xf0:			/* message exclusif ... */
			i = ef_read_F7 ( );
			RET(TOKEN_EXCLUSIVE,i,0,0)
			break;

		case 0xf1: /* DEBUT */
			p1 = ef_read_B ( );
			RET(TOKEN_BEGIN,p1,0,0)
			break;

		case 0xf2: /* FIN */
			RET(TOKEN_END,0,0,0)
			break;

		case 0xf6: /* NOP */
			RET(TOKEN_NOP,0,0,0)
			break;

		case 0xf5: case 0xf7: case 0xf8: case 0xf9:
		case 0xfa: case 0xfb: case 0xfc: case 0xfd: case 0xff:
			RET(TOKEN_XXX,c,0,0)
			break;

		default:
			canal = ( c & 0x0f ) + 1;
			switch ( c & 0xf0 )
			{
				case 0xb0:
					p1 = ef_read_B ( );
					p2 = ef_read_B ( );
					switch ( p1 )
					{
						case 0x04:
							RET(TOKEN_EXP2,canal,p1,p2)
							break;
						case 0x0B:
							RET(TOKEN_EXP,canal,p1,p2)
							break;
						case 0x40:
							RET(TOKEN_SUSTAIN,canal,p1,p2)
							break;
						case 0x7B:
							RET(TOKEN_ALLNOTEOFF,canal,p1,p2)
							break;
						default:
							RET(TOKEN_CONTROLLER,canal,p1,p2)
							break;
					}
					break;

				case 0xc0:
					p1 = ef_read_B ( );
					RET(TOKEN_PROGRAM,canal,p1,0)
					break;

				case 0xe0:
					p1 = ef_read_B ( );
					p2 = ef_read_B ( );
					RET(TOKEN_XE0,canal,p1,p2)
					break;

				case 0x80:
					p1 = ef_read_B ( );
					p2 = ef_read_B ( );
					RET(TOKEN_NOTEOFF,canal,p1,p2)
					break;

				case 0x90:
					p1 = ef_read_B ( );
					p2 = ef_read_B ( );
					RET(TOKEN_NOTEON,canal,p1,p2)
					break;

				case 0xd0:
					p1 = ef_read_B ( );
					RET(TOKEN_AFTERTOUCH,canal,p1,0)
					break;

				default:
					RET(TOKEN_XXX,canal,0,0)
					break;
			}
	}

	return 0;
}




