#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <mevt.h>


long clic_start;
int tempo;

int mevt_trk0 ( char * nom )
{
	char comment[200];
	enum TOKEN token;
	int p1, p2, p3;
	long clic;
	long ms;
	long max_ms;
	long moy_max;
	int code_cle;
	char nom_cle[40];

	evr_restart ( );
	miw_open_trk ( );

	sprintf ( comment,
		"EVT -> MID / S. Pigot - 1999 / Transcription du fichier\r\n%s\r\n",
		nom );
	printf ( "%s\n", comment );
	miw_comment ( comment );

	clic = 0;
	clic_start = 0;
	max_ms = ( 60L * 1000L + 24 * 120 / 2 ) / ( 24 * 120 );	/* tempo initial de 120 */
	moy_max = max_ms * 100;						/* moyenne * 100 des maxis */
	ms = 0;

	cle_reset();
	monopoly_reset();
	
	do
	{
		evr_token ( &token, &p1, &p2, &p3 );

		switch ( token )
		{
			case TOKEN_NOTEON:
				cle_note ( p1, p2 );
				monopoly_note ( p1, p3 );
				break;
				
			case TOKEN_NOTEOFF:
				cle_note ( p1, p2 );
				monopoly_note ( p1, 0 );
				break;

			case TOKEN_START:
				if ( clic_start == 0 )
				{
					clic_start = clic;
				}
				break;

			case TOKEN_TIME:
				ms += p1;
				miw_time_set ( clic + ( ms * CLIC ) / ( max_ms * 24 ) );
				break;

			case TOKEN_TICK:
				moy_max = ( moy_max * 10 + ms * 100 + 11 / 2 ) / 11;
				max_ms = ( max_ms + ms ) / 2;
				ms = 0;
				clic += CLIC/24;
				miw_time_set ( clic );
				break;

			/* dterminer la mesure ??? */

		}
	}
	while ( token != TOKEN_EOF );

	miw_time_reset ( );
	clic_start = ( clic_start % ( 4*CLIC ) ) - ( 4*CLIC );	/* mesure 4 temps */
	miw_time_set ( clic_start );

	tempo = ( 60L * 1000L * 100 + 24 * moy_max / 2 ) / ( 24 * moy_max );

	printf ( "Tempo : %d\n", tempo );
	miw_tempo ( tempo );
	
	printf ( "Mesure: 4/4\n" );
	miw_mesure ( 4, 4 );

	code_cle = cle_stat ( &nom_cle );
	printf ( "Clef  : %s\n", nom_cle );
	miw_clef ( code_cle );

	miw_close_trk ( );

	return 0;
}

int mevt_trk (
	int piste, char *nom, int canal_in, int canal_out, int mono,
	int pan, int prog )
{
	enum TOKEN token;
	int p1, p2, p3;
	long clic;
	long ms;
	long max_ms;
	int main_volume = 100;
	long nb_notes = 0;
	int note_on = -1;

	printf ( "Piste %s...", nom );

	evr_restart ( );
	miw_open_trk ( );

	miw_time_reset ( );
	clic = 0;
	max_ms = ( 60L * 1000L ) / tempo;
	ms = 0;
	miw_time_set ( clic_start );

	miw_trk_name ( nom );
	miw_port ( 0 );
	if ( canal_out != -1 )
	{
		miw_canal ( canal_out );
		miw_controller ( canal_out, 0x07, main_volume );	/* Ctrl 7 : Main Volume */
		if ( pan != -1 )
		{
			miw_controller ( canal_out, 0x0A, pan );		/* Ctrl 10 : Pan */
		}
		if ( prog != -1 )
		{
			miw_progchange ( canal_out, prog );
		}
		miw_aftertouch ( canal_out, 0 );
	}

	do
	{
		evr_token ( &token, &p1, &p2, &p3 );

		switch ( token )
		{

	case TOKEN_EOF:
		break;

	case TOKEN_TIME:
		ms += p1;
		miw_time_set ( clic + ( ms * CLIC ) / ( max_ms * 24 ) );
		break;

	case TOKEN_TICK:
		max_ms = ( max_ms + ms ) / 2;
		ms = 0;
		clic += CLIC/24;
		miw_time_set ( clic );
		break;

	case TOKEN_EXCLUSIVE:
		if ( piste == -1 )
			miw_exclusif ( ef_buf(), p1 );
		break;

	case TOKEN_BEGIN:
		break;

	case TOKEN_START:
		break;

	case TOKEN_STOP:
		break;

	case TOKEN_END:
		break;

	case TOKEN_NOP:
		break;

	case TOKEN_EXP:
		if ( piste == -1 )
		{
			miw_controller ( p1, 0x0B, p3 );	/* Ctrl 11 : Expression */
			main_volume = p3;
		}
		else
		{
			miw_controller ( canal_out, 0x07, p3 );	/* Ctrl 7 : Main Volume */
		}
		break;

	case TOKEN_EXP2:
	case TOKEN_SUSTAIN:
	case TOKEN_ALLNOTEOFF:
	case TOKEN_CONTROLLER:
		if ( piste == -1 )
		{
			miw_controller ( p1, p2, p3 );
		}
		else
		{
			if ( p1 == canal_in )
			{
				miw_controller ( canal_out, p2, p3 );
			}
		}
		break;

	case TOKEN_PROGRAM:
		if ( piste == -1 )
			miw_progchange ( p1, p2 );
		break;

	case TOKEN_NOTEOFF:
		if ( p1 == canal_in )
		{
			if ( mono == MONO )
			{
				if ( note_on != -1 )
				{
					p2 = note_on;
					note_on = -1;
				}
			}
			if ( p3 == 0 )
				miw_noteoff ( canal_out, p2, 0 );
			else
				miw_noteoff ( canal_out, p2, 40+p3*(128-40)/128 );
		}
		break;

	case TOKEN_NOTEON:
		if ( p1 == canal_in )
		{
			nb_notes++;
			if ( mono == MONO )
			{
				if ( note_on != -1 )
				{
					miw_noteoff ( canal_out, note_on, 0 );
					note_on = -1;
				}
				note_on = p2;
			}
			if ( p3 == 0 )
				miw_noteon ( canal_out, p2, 0 );
			else
				miw_noteon ( canal_out, p2, 40+p3*(128-40)/128 );
		}
		break;

	case TOKEN_AFTERTOUCH:
		if ( piste == -1 )
		{
			miw_aftertouch ( p1, p2 );
		}
		else
		{
			if ( p1 == canal_in )
			{
				miw_controller ( canal_out, 0x0B, main_volume +
					((128-main_volume)*p2)/128 );
					/* ctrl 11 : expression */
			}
		}
		break;

	case TOKEN_XFE:
		break;

	case TOKEN_XE0:
		break;

	case TOKEN_XXX:
		break;

		}

	}
	while ( token != TOKEN_EOF );

	miw_close_trk ( );

	printf ( "%ld note%c\n", nb_notes, nb_notes <= 1 ? ' ' : 's' );

	return 0;
}

int mevt ( char * nom )
{
	char nom_in[100];
	char nom_out[100];
	char *point;
	int piste = 1;

	strcpy ( nom_in, nom );
	strcpy ( nom_out, nom );
	
	point = strrchr ( nom_out, '.' );
	if ( point != NULL )
	{
		*point = '\0';
	}
	strcat ( nom_out, ".mid" );

	/* ouverture des fichiers */
	evr_open ( nom_in );
	miw_open ( nom_out );
	
	/* piste chef d'orchestre */
	mevt_trk0 ( nom_in );

	/* autres pistes */
	piste = 1;

	if ( monopoly(4) == MONO )
		mevt_trk (  piste++, "Lead  4", 4, 4, MONO,64,    40 );	/* violin */

	if ( monopoly(4) == POLY )
		mevt_trk (  piste++, "Upper 4", 4, 4, POLY,64+40, 48 );	/* strings1 */

	if ( monopoly(1) != VIDE )
		mevt_trk (  piste++, "Upper 1", 1, 1, POLY,64+40, 48 );	/* strings1 */

	if ( monopoly(1) != VIDE )
		mevt_trk (  piste++, "Lower 2", 2, 2, POLY,64-40, 48 );	/* strings1 */

	if ( monopoly(5) != VIDE )
		mevt_trk (  piste++, "Lower 5", 5, 5, POLY,64-40, 48 );	/* strings1 */

	if ( monopoly(3) == MONO )
		mevt_trk (  piste++, "Pedal 3", 3, 3, MONO,64,    43 );	/* contrabass */
	else
		if ( monopoly(3) == POLY )
			mevt_trk (  piste++, "Pedal 3", 3, 3, POLY,64,    43 );	/* contrabass */

	if ( monopoly(15) != VIDE )
		mevt_trk (  piste++, "Perc 15",15,10, POLY,64,     0 );	/* piano */

	/* mevt_trk ( -1, "Control",16,-1,-1, POLY,    -1 ); */
	
	/* fermeture des fichiers */
	miw_close ( );
	evr_close ( );

	return 0;
}

